import java.io.*;
import java.util.*;

/*Esercizio7 di Esercizidel22-5-17
 Si estenda (attenzione: non ridefinisca) un ADT MuPairADTX.java per coppie 
 modificabili, in un ADT, DiagMuPairADT.java per coppie diagonali, ovvero 
 coppie (x,y) tali che x.equals(y). In particolare:
 (a) Si mostri la definizione della nuova classe;
 (b) Si mostrino AF ed I della nuova rappresentazione;
 (c) Si provi la correttezza di I;
 */

/* (a) */

class DuplicatedElemException extends Exception{
}

class DiagMuPairADT<A extends Cloneable> extends MuPairADTX<A,A>{
    public DiagMuPairADT (A x, A y) throws invalidArgException {
        super(x,y);
        if (!x.equals(y)){
            super.setRight(x);
            throw new invalidArgException("DiaMuPairADT",y);
        }
    }
    public void setLeft(A x)throws invalidArgException{
                              //da aggiungere per uso effettivo
        if (!getRight().equals(x)){
            super.setLeft(x); super.setRight(x);
            throw new invalidArgException("setLeft",x);
        }
        super.setLeft(x);
    }
    public void setRight(A y)throws invalidArgException{
                              //da aggiungere per uso effettivo
        if (!getLeft().equals(y)){
            super.setLeft(y); super.setRight(y);
            throw new invalidArgException("SteRight",y);
        }
        super.setRight(y);
    }
}

/* (b-c)
 AF(c) = AF(super.c)   -- super.c indica stato concreto del super oggetto
 I(c) = getLeft()equals(getRight())
 
 Il nuovo tipo introduce un invarante sui valori coppia (x,y)\in[DiagMuPairADT<A>], 
 ovvero:
        Per Ogni v\in[DiagMuPairADT<A>], I(v)= v.getLeft()equals(v.getRight()).
 Provabile facilmente esaminando costruttori e modificatori di DiagMuPairADT.
*/

