import java.io.*;
import java.util.*;

/*
 Esercizio5 di Esercizidel22-5-17
 Si consideri la definizione di coppia in Pair.Java, per coppie non modificabili.
 Si chiede di:
 (a) Ridefinirla un API-ADT per coppie modificabili e componenti non nulli;
 (b) Fornire AF e I  di (della rappresentazione data in) MUPairADT.java;
 (c) Includere gli additionals
 (d) Fornire un caso di uso di MUPairADTX.java;
 (e) Provare la correttezza di I.
 
 public class Pair <A,B> {
    public final A left;
    public final B right;
    public Pair (A x, B y) {
        left = x;
        right = y;
    }
 }
 */

/* (a) */
class invalidArgException extends Exception{
	public String method;
	public Object arg1;
	public Object arg2;
	public invalidArgException(){
		super();
		};
	public invalidArgException(String s){
		method = s;
		};
	public invalidArgException(String s, Object a1){
		method = s; arg1 = a1;
		};
	public invalidArgException(String s, Object a1, Object a2){
		method = s; arg1 = a1; arg2 = a2;
		};	
}

interface MuPairAPI<A,B> extends Cloneable{
	public A getLeft();
	public B getRight();
	public void setLeft(A x)throws invalidArgException;
	public void setRight(B y)throws invalidArgException;
}

public class MuPairADTX<A,B> implements MuPairAPI<A,B>{
    private A left;//da nascondere
    private B right;//da nascondere
    public MuPairADTX (A x, B y) throws invalidArgException{
        if(x==null || y==null) throw new invalidArgException();
        left = x;
        right = y;
    }
    public A getLeft(){//da aggiungere per uso effettivo
        return left;
    }
    public B getRight(){//da aggiungere per uso effettivo
        return right;
    }
    public void setLeft(A x) throws invalidArgException{//da aggiungere per uso effettivo
        if (x == null) throw new invalidArgException();          
        left = x;
    }
    public void setRight(B y) throws invalidArgException {//da aggiungere per uso effettivo
        if(y==null) throw new invalidArgException();
        right = y;
    }
	//additionals: equals, clone, toString, elements
	//Nessuna necessit\`a di ri-definire equals
	public MuPairADTX<A,B> clone() {
		MuPairADTX<A,B> ret = null;
		try {
			ret = new MuPairADTX<A,B>(left,right);
		}
		catch (Exception e) {}
		return ret; 
	}
	public String toString(){
		String ret = "("+left.toString()+","+right.toString()+")";
		return ret;
	}
	//nessuna definizione per elements: MuPairADTX<A,B> non \`e un valore strutturato.
}

/* (b) 
Sia [MuPairADT<Ta,Tb>]={(x,y) | x\inTa, y\inTb, Ta\in[A], Tb\in[B]}, l'insieme dei valo-
ri astratti definiti da MuPairADT<Ta,Tb>. Allora, per ogni valore concreto c esprimibile 
con lo stato concreto definito dai fields della classe:
AF(c) = (c.left,c.right)
I(c) = c.left!=null & c.right!=null
*/

/* (c) 
 Notare che String e Integer non sono Cloneable. Per questa ragione ho rilassato i vincoli:
 A extends Cloneable e B extends Cloneable nei generici della dichiarazione di MuPairADTX<A,B>.
 Allo stesso tempo in rigo 77 ho messo left e right come nel caso di valori non Cloneable (vedi
 "Clone: Metodologia" in registro attivita' di martedi 23/5/2017. 
*/

 class main{
    public static void main(String args[]) throws invalidArgException,
                                                    CloneNotSupportedException{
        MuPairADTX<String,Integer> myAddress =
                               new MuPairADTX<String,Integer>("via Pontecorvo",4);
        System.out.println("l'indirizzo e' " + myAddress.getLeft() + ", "
                           + myAddress.getRight());
        myAddress.setRight(12);
        System.out.println("l'indirizzo e' cambiato in " + myAddress.getLeft() + ", "
						   + myAddress.getRight()); 
		MuPairADTX<String,Integer> duplicateIt = myAddress.clone();
		System.out.println("are myAddress and duplicateIt behaviorally the same? " 
						   + myAddress.equals((MuPairADTX<String,Integer>)duplicateIt));
        System.out.println("the program introduces the following values:");		
        System.out.println("myAddress = " + myAddress.toString());		
        System.out.println("duplicateIt = " + duplicateIt.toString());
    }
}
 
/*
 Marco-Bellias-MacBook-Pro-2:AltriEsercizi6Listings marcob$ cd Soluzioni/ZcodeMPAX/
 Marco-Bellias-MacBook-Pro-2:ZcodeMPAX marcob$ java main
 l'indirizzo e' via Pontecorvo, 4
 l'indirizzo e' cambiato in via Pontecorvo, 4
 are myAddress and duplicateIt behaviorally the same? false
 the program introduces the following values:
 myAddress = (via Pontecorvo,4)
 duplicateIt = (via Pontecorvo,4)
 Marco-Bellias-MacBook-Pro-2:ZcodeMPAX marcob$ 
*/ 

/* (d)
 Dobbiamo provare che I(c)= c.left!=null & c.right!=null e' sempre verificato dallo 
 stato di un valore astratto di tipo MuPairADTX.
 Fatto1: Costruttori. Il primo stm controlla che il valore (x,y) sia costruito solo se 
         x!=null!=y.
 Fatto2: Modificatore "setLeft" non soddisfa I(c)
 */
